/*
Scheduling simulator with  implementation of Round Robin, short job first, and highest priority job first algorithms,  versin 1.0, Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutierrez Pallares

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.

Feel free to send comments or questions to: 
Ricardo Santacruz (prodor@gmail.com) Alejandro Prez (cw_fromhell@yahoo.com.mx)Juan Gutierrez (jlgpallares@hotmail.com)

Scheduling simulator with  implementation of Round Robin, short job first, and highest priority job first algorithms, versin 1.0, Copyright (C) 2008 Ricardo Santacruz Bautista, Alejandro Prez Reyna, Juan Luis Gutierrez Pallares 
*/

// Run() is called from Scheduling.main() and is where
// the scheduling algorithm written by the user resides.
// User modification should occur within the Run() function.

import java.util.Vector;
import java.io.*;

public class SchedulingAlgorithm {

  public static Results Run(int runtime, Vector processVector, Results result) {
    int i = 0;
    int comptime = 0;
    int currentProcess = 0;
    int previousProcess = 0;
    int completeProcess=0;
    int size = processVector.size();
    int completed = 0;
    int max=-1;
    String resultsFile = "Summary-Processes";
    result.schedulingType = "Batch (Nonpreemptive)";
    result.schedulingName = "Highest priority job first"; 
    try {
      //BufferedWriter out = new BufferedWriter(new FileWriter(resultsFile));
     // OutputStream out = new FileOutputStream(resultsFile);
      PrintStream out = new PrintStream(new FileOutputStream(resultsFile));
      sProcess proces,proces2;
      proces2 = (sProcess) processVector.elementAt(1);
      for (i = 0; i <= size - 1; i++) {
            proces = (sProcess) processVector.elementAt(i);
            if (proces.priority >max) { 
              max=proces.priority;
              currentProcess=i;
            }
          }
      sProcess process = (sProcess) processVector.elementAt(currentProcess);
      sProcess process2;
      out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
      System.out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+ ")");
      while (comptime < runtime) {
      	max=-1;
        if (process.cpudone == process.cputime) {
          completed++;
          out.println("Proceso: " + currentProcess + " completado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+ ")");
          System.out.println("Proceso: " + currentProcess + " completado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
          if (completed == size) {
            result.compuTime = comptime;
            out.close();
            return result;
          }
          completeProcess=currentProcess;
          for (i = 0; i <= processVector.size() - 1; i++) {
          	if(completeProcess==i)
          		continue;
            process = (sProcess) processVector.elementAt(i);
            if (process.cpudone<process.cputime&&process.priority >max) { 
              max=process.priority;
              currentProcess=i;
            }
          }
          process = (sProcess) processVector.elementAt(currentProcess);
          out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked +" "+process.priority+ ")");
          System.out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
        }      
        if (process.ioblocking == process.ionext) {
          out.println("Proceso: " + currentProcess + " I/O bloqueado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked +" "+process.priority+ ")");
          System.out.println("Proceso: " + currentProcess + " I/O bloqueado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
          process.numblocked++;
          process.ionext = 0; 
          previousProcess = currentProcess;
      		for (i = 0; i <= processVector.size() - 1; i++) {
      		if(previousProcess==i)
          		continue;
            process = (sProcess) processVector.elementAt(i);
            if (process.cpudone<process.cputime&&process.priority >max) { 
              max=process.priority;
              currentProcess=i;
            }
          }
          process = (sProcess) processVector.elementAt(currentProcess);
          out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
          System.out.println("Proceso: " + currentProcess + " registrado... (" + process.cputime + " " + process.ioblocking + " " + process.cpudone + " " + process.numblocked + " "+process.priority+")");
        }        
        process.cpudone++;
        //if(process.priority>0)  
        //	--process.priority;     
        if (process.ioblocking > 0) {
          process.ionext++;
        }
        comptime++;
      }
      out.close();
    } catch (IOException e) { /* Handle exceptions */ }
    result.compuTime = comptime;
    return result;
  }
}
